/* ------------------------------------------------------------ */
/*
HTTrack Website Copier, Offline Browser for Windows and Unix
Copyright (C) Xavier Roche & Yann Philippot

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


Important notes:

- We hereby ask people using this source NOT to use it in purpose of grabbing
emails addresses, or collecting any other private informations on persons.
This would disgrace our work, and spoil the many hours we spent on it.


This project has been developed by Xavier Roche and Yann Philippot,
and originally supervised by Daniel Carr and Patrick Ducrot from
"ISMRA - Ensi Caen", computing department (http://www.ismra.fr)
Please visit our Web site: http://httrack.free.fr
*/


/* ------------------------------------------------------------ */
/* File: Global #define file                                    */
/* ------------------------------------------------------------ */

// Fichier runissant l'ensemble des defines

#ifndef HTTRACK_GLOBAL_DEFH
#define HTTRACK_GLOBAL_DEFH

// Version
#define HTTRACK_VERSION      "3.00-ALPHA-12"
#define HTTRACK_VERSIONID    "2.98.12"
#define HTTRACK_AFF_VERSION  "3.x"
#define HTTRACK_AFF_WARNING  "This is an ALPHA version of WinHTTrack Website Copier 3.0"
// HTSLib
//#define HTSVERSION ""



// Dfinition plate-forme
#include "htssystem.h"
#include "htsconfig.h"

// Socket windows ou socket unix
#if HTS_PLATEFORM==1
#define HTS_WIN 1
#else
#define HTS_WIN 0
#endif

// compatibilit DOS
#if HTS_WIN
#define HTS_DOSNAME 1
#else
#define HTS_DOSNAME 0
#endif

/*
#if HTS_XGETHOST
#if HTS_PLATEFORM==1
#ifndef __cplusplus
#undef HTS_XGMETHOD
#undef HTS_XGETHOST
#endif
#endif
#else
#undef HTS_XGMETHOD
#undef HTS_XGETHOST
#endif
*/

/* rc file */
#if HTS_WIN
#define HTS_HTTRACKRC "httrackrc"
#else
#define HTS_HTTRACKRC ".httrackrc"
#endif

/* Gestion des tables de hashage */
#define HTS_HASH_SIZE 20147
/* Copyright (C)Xavier Roche & Yann Philippot '2000 */
#define HTTRACK_AFF_AUTHORS "[XR/YP'2000]"
#define HTS_DEFAULT_FOOTER "<!-- Mirrored from %s by HTTrack Website Copier/"HTTRACK_AFF_VERSION" "HTTRACK_AFF_AUTHORS" -->"
#define HTS_UPDATE_WEBSITE "http://httrack.free.fr/update.php3?Product=HTTrack&Version="HTTRACK_VERSIONID

#define H_CRLF "\x0d\x0a"
#define CRLF   "\x0d\x0a"
#if HTS_WIN
#define LF "\x0d\x0a"
#else
#define LF "\x0a"
#endif

/* quivaut  "paramtre vide", par exemple -F (none) */
#define HTS_NOPARAM "(none)"
#define HTS_NOPARAM2 "\"(none)\""

/* maximum et minimum */
#define maximum(A,B) ( (A) > (B) ? (A) : (B) )
#define minimum(A,B) ( (A) < (B) ? (A) : (B) )

/* chaine vide? */
#define strnotempty(A) (((A)[0]!='\0') ? 1 : 0)

/* optimisation inline si possible */
#ifdef __cplusplus
#define HTS_INLINE inline
#else
#define HTS_INLINE
#endif

#if HTS_WIN
#else
#define __cdecl 
#endif

/* mode pour mkdir ET chmod (accs aux fichiers) */
#define HTS_PROTECT_FOLDER (S_IRUSR|S_IWUSR|S_IXUSR)
#if HTS_ACCESS
#define HTS_ACCESS_FILE (S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH)
#define HTS_ACCESS_FOLDER (S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH)
#else
#define HTS_ACCESS_FILE (S_IRUSR|S_IWUSR)
#define HTS_ACCESS_FOLDER (S_IRUSR|S_IWUSR|S_IXUSR)
#endif

/* vrifier la dclaration des variables prprocesseur */
#ifndef HTS_DOSNAME
#error | HTS_DOSNAME Has not been defined.
#error | Set it to 1 if you are under DOS, 0 under Unix.
#error | Example: place this line in you source, before includes:
#error | #define HTS_DOSNAME 0
#error
#error
#endif
#ifndef HTS_ACCESS
/* Par dfaut, accs  tous les utilisateurs */
#define HTS_ACCESS 1
#endif

/* fflush sur stdout */
#define io_flush { fflush(stdout); fflush(stdin); }



/* HTSLib */

// Cache DNS, acclre les rsolution d'adresses
#define HTS_DNSCACHE 1

// ID d'une pseudo-socket locale pour les file://
#define LOCAL_SOCKET_ID -500000

// taille de chaque buffer (10 sockets 650 ko)
#define TAILLE_BUFFER 65535

#if HTS_WIN
#else
// use pthreads.h
#define USE_PTHREAD 1
#endif

#if HTS_WIN
#define USE_BEGINTHREAD 1
#else
#if USE_PTHREAD
#define USE_BEGINTHREAD 1
#else
/* sh*t.. */
#define USE_BEGINTHREAD 0
#endif
#endif

/* ------------------------------------------------------------ */
/* Debugging                                                    */
/* ------------------------------------------------------------ */

// dbuggage
#define DEBUG_SHOWTYPES 0
// backing debug
#define BDEBUG 0
// chunk receive
#define CHUNKDEBUG 0
// realloc links debug
#define MDEBUG 0
// cache debug
#define DEBUGCA 0
// savename debug
#define DEBUG_SAVENAME 0
// debug robots
#define DEBUG_ROBOTS 0
// debug hash
#define DEBUG_HASH 0
// Vrification d'intgrit
#define DEBUG_CHECKINT 0
// nbr sockets debug
#define NSDEBUG 0
// tracer mallocs
#define HTS_TRACE_MALLOC 0

// dbuggage HTSLib
#define HDEBUG 0
// surveillance de la connexion
#define CNXDEBUG 0
// debuggage cookies
#define DEBUG_COOK 0
// dbuggage hard..
#define HTS_WIDE_DEBUG 0
// debuggage deletehttp et cie
#define HTS_DEBUG_CLOSESOCK 0
// debug tracage mmoire
#define MEMDEBUG 0


#endif

